/*;  makeGridData.cc {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.2 $$ {\rhead{\sl makeGridData.cc\quad\thepage}} */
/*;  $$Date: 1997/03/12 10:44:09 $$  */
/*;  $$Source: /home/sakakiba/DEM/altitude/makeGridData.cc,v $$  */

// 2åñ̤ǥǡڤФ褦˽
// Ω 2005ǯ728

/*
  makeGridData.cc
  ڿ; 250m åɸǡ顢åɤξϿ
  ǡեȡɸǡϿǡեޤ

  ѥ
  makefile 

  ¹Է
  makeGridData250 makeGridData250.dat(ϥǡե̾)

  ϥǡե(makeGridData.dat)ν 

  ()
  5 2 3
  asamiya.alt.dat 1 2
  seta.alt.dat 1 3
  shimagahara.alt.dat 2 1
  shigaraki.alt.dat 2 2
  mikumo.alt.dat 2 3
  523517
  523500
  523588  ADaido.dat
  GDaido.dat
  dataNum.dat

  ϥե 

  1
  (Ͽ޿Ͽޤΰ(x)κ͡Ͽޤΰ(y)κ)

  2ܤ(Ͽ޿+1)ܤޤ
  (Ͽ̾Ͽޤΰ(x)Ͽޤΰ(y))


  (Ͽ޿+2)
  Ȥʤ룲åֹ

  (Ͽ޿+3)
  ǡڤФüΣåֹ

  (Ͽ޿+4)
  ǡڤФüΣåֹ

  ϥե 

  åɤĺϿǡե(()  ADaido.dat)
  (ֹ桢xɸyɸzɸ)

  åɤξϿǡե(()  GDaido.dat)
  (åɤֹ桢åɤΰ֡åɤĺֹ)

  ɸǡåɤϿǡե
  (()  dataNum.dat)

  */

#include <iomanip>    // changed from *.h on Oct. 4, 2007
#include <iostream>   // changed from *.h on Oct. 4, 2007
#include <fstream>    // changed from *.h on Oct. 4, 2007
#include <sstream>    // changed from strstream.h on Oct. 4, 2007
#include <ctype.h>
#include <math.h>
#include <stdlib.h>
#include "dfstream.h"

using namespace std;   // added on Oct. 4, 2007

typedef double Metric;

const int BUFFLEN = 1611; // ɤ߹ࣱԤʸĹ
const int DATAVAL = 320;  // Ͽޥǡ1Ԥ˵ϿƤǡ
const int TOTALOFILES = 3; // ϥե

struct MapInfo		// Ͽޤ֤̾˴ؤ빽¤
{
  int m;		// Ͽޤΰ(x)
  int n;		// Ͽޤΰ(y)
  char dname[BUFFLEN];	// Ͽ̾
  int pnum;  // 켡åоݥǡκǽֹ
  int rnum;  // 켡åоݥǡιԿ
  int cnum;  // 켡åоݥǡ
  int snum;  // ¦Τ٤Ƥΰ켡åоݥǡԿ
  int wnum;  // ¦Τ٤Ƥΰ켡åоݥǡ
};

class GeoCoord {	// ɸ饹
 protected:
  int deg;		// 
  int min;		// ʬ
  double sec;		// 
 public:
  GeoCoord() { deg = 0; min = 0; sec = 0; }
  GeoCoord(const GeoCoord& coord) 
  { 
    deg = coord.deg; min = coord.min; sec = coord.sec; 
  }
  GeoCoord(int degVal, int minVal, double secVal) 
  { 
    SetVal(degVal, minVal, secVal); 
  }
//  GeoCoord& operator= (const GeoCoord& coord)
  void operator= (const GeoCoord& coord)
  { 
    deg = coord.deg; min = coord.min; sec = coord.sec; 
  }
  void SetVal(int degVal, int minVal, double secVal) 
  { 
    deg = degVal; min = minVal; sec = secVal;
  }
  int Degree() const { return deg; }
  int Minute() const { return min; }
  double Second() const { return sec; }
  double ChangeDeg()
  {
    return ((double)deg + (double)min / 60. + sec / 3600.);
  }
};

class Coordinate {	// κɸ饹
 protected:
  Metric xd;		// x ɸ
  Metric yd;		// y ɸ
 public:
  Coordinate() { xd = 0; yd = 0; }
  Coordinate(const Coordinate& coordinate) 
  { xd = coordinate.xd;  yd = coordinate.yd; }
  Coordinate(Metric xVal, Metric yVal) { SetVal(xVal, yVal); }
//  Coordinate& operator= (const Coordinate& coordinate) 
  void operator= (const Coordinate& coordinate) 
  { xd = coordinate.xd;  yd = coordinate.yd; }
  void SetVal(Metric xVal, Metric yVal) { xd = xVal; yd = yVal; }
  Metric x() const { return xd; }
  Metric y() const { return yd; }
};

void CalcCoord(
  int recordVal,	        // ϿޤΥ쥳ֹ
  int nth,		        // 쥳ɤβܤεϿ
  GeoCoord& nw_longti,		// Ͽޤη
  GeoCoord& nw_lati,		// Ͽޤΰ
  GeoCoord& p_longti,		// ɸη
  GeoCoord& p_lati		// ɸΰ
)
{
  double longtisec, latisec;
  latisec = nw_lati.Second() - ((double)recordVal - 1.) * 7.5 - 3.75;
  longtisec = nw_longti.Second() + ((double)nth - 1.) * 11.25 + 5.625;
  int latimin = nw_lati.Minute();
  int longtimin = nw_longti.Minute();
  int latideg = nw_lati.Degree();
  int longtideg = nw_longti.Degree();
  while (1)
    {
      if (latisec < 0) 
	{
	  latimin--; latisec += 60.;
	}
      else
	break;
    }
  while (1)
    {
      if (longtisec - 60. >= 0) 
	{
	  longtimin++; longtisec -= 60.;
	}
      else
	break;
    }
  while (1)
    {
      if (latimin < 0) 
	{
	  latideg--; latimin += 60;
	}
      else
	break;
    }
  while (1)
    {
      if (longtimin - 60 >= 0) 
	{
	  longtideg++; longtimin -= 60;
	}
      else
	break;
    }
  
  p_longti.SetVal(longtideg, longtimin, longtisec);
  p_lati.SetVal(latideg, latimin, latisec);
  return;
}

void GctUtm(
  Coordinate& geo_coord,	// а (ñ )
  Coordinate& utm_coord,	// UTM ɸ (ñ km)
  double origlongitude		// η (ñ )
)
{
  double longitude = geo_coord.x();
  double latitude = geo_coord.y();

  double lambda, phi;
  double pi, lambda0, e2, ed2, a, b, b1, b2, b3,
    l, t2, gamma2, f, f1, f2, A, B, g, g1, g2;

  pi = 4.0*atan(1.0);
  e2 = 0.006674372;  /* ΥΨΣ */
  ed2 = 0.006719219; /* ΥΨΣ */
  a = 6377.397155;   /* ϵʱΤĹȾ(km) */
  b = 6356.078963;   /* ϵʱΤûȾ(km) */
//  lambda0 = cc*pi/180.0;    /* ñ̤饸Ѵ */
  lambda0 = origlongitude*pi/180.0;    /* ñ̤饸Ѵ */
  lambda = longitude;
  lambda = lambda*pi/180.0; /* ñ̤饸Ѵ */
  phi = latitude;
  phi = phi*pi/180.0;       /* ñ̤饸Ѵ */
  A = a/sqrt(1.-e2*pow(sin(phi), 2));
  b1 = 0.998329312962;
  b2 = 0.00501415801;
  b3 = 0.00001049328;
  B = a*(b1*phi-b2*sin(phi)*cos(phi)
     +b3*(sin(phi)*pow(cos(phi), 3)-pow(sin(phi), 3)*cos(phi)));
  l = lambda-lambda0;
  t2 = pow(tan(phi), 2);
  gamma2 = ed2*(pow(cos(phi), 2));
  f1 = 1.0-t2+gamma2;
  f2 = 5.0-18.0*t2+pow(t2, 2)+14.0*gamma2-58.0*t2*gamma2;
  f = A*l*cos(phi)*(1.0+1.0/6.0*pow(l, 2)*pow(cos(phi), 2)
		    *(f1+1.0/20.0*pow(l, 2)*pow(cos(phi), 2)*f2));
  g1 = 5.0-t2+9.0*gamma2+4.0*pow(gamma2, 2);
  g2 = 61.0-58.0*t2+pow(t2, 2)+270.0*gamma2-330.0*t2*gamma2;
  g = B+0.5*A*pow(l, 2)*sin(phi)*cos(phi)
      *(1.0+1.0/12.0*pow(l, 2)*pow(cos(phi), 2)
      *(g1+1.0/30.0*pow(l, 2)*pow(cos(phi), 2)*g2));
  double ue = (0.9996*f+500.0);
  double un = (0.9996*g);
  utm_coord.SetVal(ue, un);

  return;
}


int insideArea(
  int Loc2ndmesh,		// üΣå女(ڤФϰϤλ)
  int SW2ndmesh,		// üΣå女(ڤФϰϤλ)
  int NE2ndmesh		// üΣå女(ڤФϰϤλ)
)
// Loc2ndmesh  SW2ndmesh  NE2ndmesh ΰʤ 1 򡢤Ǥʤ
// 0 ֤
{
	int Loc1stmeshE, Loc1stmeshN, Loc2ndmeshE, Loc2ndmeshN;
	int SW1stmeshE, SW1stmeshN, SW2ndmeshE, SW2ndmeshN;
	int NE1stmeshE, NE1stmeshN, NE2ndmeshE, NE2ndmeshN;
	int SW_E, SW_N, NE_E, NE_N, LocE, LocN;
	
	Loc1stmeshN = Loc2ndmesh/10000;
	Loc1stmeshE = Loc2ndmesh/100-Loc1stmeshN*100;
	Loc2ndmeshN = (Loc2ndmesh - Loc1stmeshN*10000 - Loc1stmeshE*100)/10; 
	Loc2ndmeshE = Loc2ndmesh - Loc1stmeshN*10000 - Loc1stmeshE*100 - Loc2ndmeshN*10; 
	
	SW1stmeshN = SW2ndmesh/10000;
	SW1stmeshE = SW2ndmesh/100-SW1stmeshN*100;
	SW2ndmeshN = (SW2ndmesh - SW1stmeshN*10000 - SW1stmeshE*100)/10; 
	SW2ndmeshE = SW2ndmesh - SW1stmeshN*10000 - SW1stmeshE*100 - SW2ndmeshN*10; 
	
	NE1stmeshN = NE2ndmesh/10000;
	NE1stmeshE = NE2ndmesh/100-NE1stmeshN*100;
	NE2ndmeshN = (NE2ndmesh - NE1stmeshN*10000 - NE1stmeshE*100)/10; 
	NE2ndmeshE = NE2ndmesh - NE1stmeshN*10000 - NE1stmeshE*100 - NE2ndmeshN*10; 

    SW_N = SW2ndmeshN+1; //üƤ̤ˤ2å夫
    SW_E = SW2ndmeshE+1; //üƤˤ2å夫
    
    NE_N = (NE1stmeshN-SW1stmeshN)*8 + NE2ndmeshN+1; //üƤ̤ˤ2å夫
    NE_E = (NE1stmeshE-SW1stmeshE)*8 + NE2ndmeshE+1; //üƤˤ2å夫

    LocN = (Loc1stmeshN-SW1stmeshN)*8 + Loc2ndmeshN+1; //üƤ̤ˤ2å夫
    LocE = (Loc1stmeshE-SW1stmeshE)*8 + Loc2ndmeshE+1; //üƤˤ2å夫

    if (SW_E <= LocE && LocE <= NE_E) {
		if (SW_N<= LocN && LocN <= NE_N) {
			return (1);
		}
	}
    return (0);    
}


int
OutputCoord(
  char* ifname,     // ϥե̾
  int totalcount,   // ĺ
  char* fname,      // ϥե̾
  double lg,        // Ȥʤ󼡥åѤη()
  double lt,        // Ȥʤ󼡥åѤΰ()
  int SW2ndmesh,    // üΣå女(ڤФϰϤλ)
  int NE2ndmesh,    // üΣå女(ڤФϰϤλ)
  int *rnum,        // 켡åоݥǡԿ
  int *cnum         // 켡åоݥǡԿ
)
{
  ifstream input(ifname);
  if(!input) {
    cerr << "Cannot open " << ifname << endl;
    exit(1);
  }

  // եإå쥳ɤ
  char headstr[BUFFLEN];  // إåԡ1ԡˤ˳Ǽ롣
  char tempstr[BUFFLEN];
  char valstr[BUFFLEN];
  int dVal, mVal, sVal;
  input.getline(headstr, BUFFLEN);  // ǥإåɤ߹

  // istrstream ihstr(headstr);  // comment out Ocd. 4, 2007
  istringstream ihstr((const char*)headstr);  // added Ocd. 4, 2007
  ihstr.get(tempstr, 30);   // (30-1) ʸɤФ
  ihstr.get(valstr, 4); dVal = atoi(valstr); // (4-1)ʸƤѴ
  ihstr.get(valstr, 3); mVal = atoi(valstr); // (3-1)ʸƤѴʬ
  ihstr.get(valstr, 3); sVal = atoi(valstr); // (3-1)ʸƤѴ
  GeoCoord swlati(dVal, mVal, sVal);         // 1åκΰ
  cout << "southwest latitude   : D " << dVal 
       << "\tM " << mVal << "\tS " << sVal << endl;
  ihstr.get(valstr, 4); dVal = atoi(valstr);  
  ihstr.get(valstr, 3); mVal = atoi(valstr);
  ihstr.get(valstr, 3); sVal = atoi(valstr);
  GeoCoord swlongti(dVal, mVal, sVal);       // 1åκη
  cout << "southwest longtitude : D " << dVal 
       << "\tM " << mVal << "\tS " << sVal << endl;
  ihstr.get(valstr, 4); dVal = atoi(valstr); 
  ihstr.get(valstr, 3); mVal = atoi(valstr); 
  ihstr.get(valstr, 3); sVal = atoi(valstr); 
  GeoCoord nelati(dVal, mVal, sVal);         // 1åαΰ
  cout << "northeast latitude   : D " << dVal 
       << "\tM " << mVal << "\tS " << sVal << endl;
  ihstr.get(valstr, 4); dVal = atoi(valstr); 
  ihstr.get(valstr, 3); mVal = atoi(valstr); 
  ihstr.get(valstr, 3); sVal = atoi(valstr); 
  GeoCoord nelongti(dVal, mVal, sVal);       // 1åαη
  cout << "northeast longtitude : D " << dVal 
       << "\tM " << mVal << "\tS " << sVal << endl;

//  ofstream output1;
  ofstream output2;
  if (totalcount == 1) {
//      output1.open("TGeoCoord.data");
//      if(!output1) 
//	{
//	  cerr << "Cannot open GeoCoord.data" << endl;
//	  exit(1);
//	}
//      output1 << "# ( ʬ )  ( ʬ )  ɸ(0.1m)\n";

    output2.open(fname);
    if(!output2) {
      cerr << "Cannot open " << fname << endl;
      exit(1);
    }
    output2 << "# ֹ  "
      << "UTM ɸ(κɸ(km)  κɸ(km))"
      << "  ɸ(0.1m)\n";
  }
  else {
//      output1.open("TGeoCoord.data", ios::app);
//      if(!output1) 
//	{
//	  cerr << "Cannot open GeoCoord.data" << endl;
//	  exit(1);
//	}

    output2.open(fname, ios::app);
    if(!output2) {
      cerr << "Cannot open " << fname << endl;
      exit(1);
    }
  }

  // UTM 濴

  double clg;
  if (120. <= lg && lg < 126.) clg = 123.;
  else if (126. <= lg && lg < 132.) clg = 129.;
  else if (132. <= lg && lg < 138.) clg = 135.;
  else if (138. <= lg && lg < 144.) clg = 141.;
  else if (144. <= lg && lg < 150.) clg = 147.;
  else if (150. <= lg && lg < 156.) clg = 153.;
  else exit(1);

  // Ȥʤ󼡥åѤ UTM ɸ

  Coordinate c_geo(lg, lt);
  Coordinate c_utm;
  GctUtm(c_geo, c_utm, clg);

//   	// for debugging
//   	cout << c_utm.x() << endl;
//   	cout << c_utm.y() << endl;

  // 쥳ɤ
  char str[BUFFLEN];
  int Loc2ndmesh;     // о°2å女
  int Loc2ndlatitude;   // о°2å女
  int Loc2ndlongitute;  // о°2å女
  

  *rnum = 0; // 켡åоݥǡԿ
  *cnum = 0; // 켡åоݥǡ
  while (input.getline(str, BUFFLEN)) {  // ɸǡɤ߹ߤޤ
    char meshstr[BUFFLEN];
    char recstr[BUFFLEN];
    char altistr[6];

    //   istrstream istr(str);  // comment out Ocd. 4, 2007
    istringstream istr((const char*)str); // added Ocd. 4, 2007
    istr.get(meshstr, 7); // Ƭ 6 ࡧå女
    int meshCode = atoi(meshstr);  // å女ɤѴ롣
    istr.get(recstr, 4);  //  3 ࡧ쥳ֹ
    int recNum = atoi(recstr);  // 쥳ֹѴ롣
        // ա쥳ֹ 1  320 Ȥϸ¤ʤ٤Ƴ
        // ԤϥǡʤƤ롣Ω2005.07.27
        
    int count = 1;  // ܤɸͤ
    int icnum = 0;  // оΰǲܤɸͤ
    while (istr.get(altistr, 6)) { // 6 夺ɸɤ߹ࡣ
      if (count > 320) break;
           
      // 2 åñ̤ǥǡڤФˡоϰ⤫ɤȽǤ
      // ϰϳʤХǡ񤭽Ф˥롼פ󤹡Ω 2005.07.27
      // int recNum: 쥳ֹʤѤ̤ΰ֤׻
      // int count: ǡ¤ӤκθĿʤѤΰ֤׻

      // о°2å女ɤη׻
      Loc2ndlatitude = 7-(recNum-1)/40;
      Loc2ndlongitute = (count-1)/40;
      Loc2ndmesh = meshCode + 10*Loc2ndlatitude + Loc2ndlongitute;

      //cout << Loc2ndmesh << " SW: " << SW2ndmesh << " NE: " << NE2ndmesh << 
      //" inout: " << insideArea(Loc2ndmesh, SW2ndmesh, NE2ndmesh) <<endl;

      if (insideArea(Loc2ndmesh, SW2ndmesh, NE2ndmesh)==0) {  // оΰ賰ä
        count++;
        continue;
      }

      // ʹߤоΰäν
      icnum++; // äԤ򥫥Ȥ롣
      if (icnum ==1) *rnum = *rnum + 1; // äԤǹԿ򥫥Ȥ롣

// modified by Yutaka ICHIKAWA (Thu Jul 29 12:17:38 1999)
// ΥɤǤϷ¬(-9999)бƤʤΤǡ
// 			// ɸͤɤ߼
// 			istr.get(*(altistr + i), 6);
// 			if (!isdigit(**(altistr + i))) break;

      // ɸͤʸ󤫤Ѵ
      double altivalue;
      // istrstream ialtistr(altistr);  // comment out Ocd. 4, 2007
      istringstream ialtistr((const char*)altistr); // added Ocd. 4, 2007
      ialtistr >> altivalue; // ɸͤѴ

      // ɸͤɸ
      GeoCoord p_longti;		// ɸη
      GeoCoord p_lati;		// ɸΰ
      CalcCoord(recNum, count, swlongti, nelati, p_longti, p_lati);

//	  output1 << setprecision(3) << setiosflags(ios::fixed)
//		  << p_longti.Degree() 
//		  << setw(5) << p_longti.Minute()
//		  << setw(12) << p_longti.Second() 
//		  << setw(10) << p_lati.Degree() 
//		  << setw(5) << p_lati.Minute() 
//		  << setw(12) << p_lati.Second() 
//		  << setw(10) << altivalue << "\n";

      // ɸͤ UTM ɸ
      Coordinate p_geo(p_longti.ChangeDeg(), p_lati.ChangeDeg());
      Coordinate p_utm;
//			GctUtm(p_geo, p_utm);
      GctUtm(p_geo, p_utm, clg);

// 			output2 << totalcount
// 					<< setprecision(3) << setiosflags(ios::fixed)
// 					<< setw(15) << p_utm.x()  
// 					<< setw(15) << p_utm.y()
// 					<< setw(15) << altivalue << "\n";

      output2 << totalcount   // ĺֹ
        << setprecision(6) << setiosflags(ios::fixed)
        << " " << p_utm.x() - c_utm.x()   // x ɸ
        << " " << p_utm.y() - c_utm.y()   // y ɸ
        << " " << altivalue << endl;      // z ɸ

      count++;
      totalcount++;
    }
    if (*rnum == 1) { // ΰܤɤ߼꤬äȤ
      *cnum = icnum;
    }
  }

  input.close();
//  output1.close();
  output2.close();


  Coordinate sw(swlongti.ChangeDeg(), swlati.ChangeDeg());
  Coordinate ne(nelongti.ChangeDeg(), nelati.ChangeDeg());
  Coordinate swUtm, neUtm;
//   GctUtm(sw, swUtm);
//   GctUtm(ne, neUtm);
  GctUtm(sw, swUtm, clg);
  GctUtm(ne, neUtm, clg);

//  cout << setprecision(3) << setiosflags(ios::fixed) 
//       << "geocoord SW: x = " << swlongti.ChangeDeg() 
//       << "\ty = " << swlati.ChangeDeg() << endl;
//  cout << "utmcoord SW: x = " << swUtm.x() << "\ty = " << swUtm.y() 
//       << endl;
//  cout << "geocoord NE: x = " << nelongti.ChangeDeg()
//       << "\ty = " << nelati.ChangeDeg() << endl;
//  cout << "utncoord NE: x = " << neUtm.x() << "\ty = " << neUtm.y()
//       << endl;

  return totalcount;
}



/************************** ᥤؿ **************************************/

int main(int argc, char* argv[])
{
  if (argc != 2) { 
    cerr << "usage: " << argv[0] 
	 << " InputDataFile"
	 << endl; 
    exit(1);
  }

  // ***** ɸǡ *****
  dfstream input(argv[1]);
  if(!input) {
    cerr << "Cannot open " << argv[1] << endl;
    exit(1);
  }

  int totalinput, maxm, maxn;
  char str0[BUFFLEN];
  input.getline(str0, BUFFLEN);
  //istrstream istr0(str0);  // comment out Ocd. 4, 2007
  istringstream istr0((const char*)str0); // added Ocd. 4, 2007 
  istr0 >> totalinput >> maxm >> maxn;

  int grid[maxm][maxn];
  for(int im = 0; im < maxm; im++)
    {
      for (int in = 0; in < maxn; in++)
	grid[im][in] = 0;
    }

  MapInfo minfo[totalinput]; 
  for (int i = 0; i < totalinput; i++) { // ϥեi ϥǡεҽ
    char str[BUFFLEN];
    input.getline(str, BUFFLEN);
    //istrstream istr(str);  // comment out Ocd. 4, 2007
    istringstream istr((const char*)str); // added Ocd. 4, 2007

    istr >> minfo[i].dname >> minfo[i].m >> minfo[i].n;
    grid[minfo[i].m - 1][minfo[i].n - 1] = 1;  // grid[][] ˤоϰΰ켡å1
                                               // Ǥʤ 0
    // ϰ켡åγǧɽ
    cout << minfo[i].dname << " " << minfo[i].m << " " 
    << minfo[i].n << "\n";
  }

  for(int im = 0; im < maxm; im++) { // ϥեκ鱦
    for (int in = 0; in < maxn; in++)   // ϥեβ
      cout << "grid[" << im << "][" << in << "] = " << grid[im][in] << endl;
  }

  // added by Yutaka ICHIKAWA (Mon Nov  8 15:15:34 1999)

  // ɸδȤʤ󼡥åֹɤ߼

  char refmesh[7]; // 󼡥åֹ
  char str[BUFFLEN];
  input.getline(str, BUFFLEN);
  //istrstream istr(str);  // comment out Ocd. 4, 2007
  istringstream istr((const char*)str); // added Ocd. 4, 2007
  istr >> refmesh ;

  // Ȥʤ󼡥åüηаٺɸ UTM ɸ

  double lg; // ()
  double lt; // ()

  char tmp[3];
  tmp[0] = refmesh[0]; tmp[1] = refmesh[1]; tmp[3] = '\0';
  int firstmeshns = atoi(tmp);
  tmp[0] = refmesh[2]; tmp[1] = refmesh[3]; tmp[3] = '\0';
  int firstmeshew = atoi(tmp);
  tmp[0] = refmesh[4]; tmp[1] = '\0';
  int numns = atoi(tmp);
  tmp[0] = refmesh[5]; tmp[1] = '\0';
  int numew = atoi(tmp);

  lt = (double)firstmeshns * 2. / 3. + (double)numns / 12.;
  lg = (double)firstmeshew + 100. + (double)numew / 8.;

//   	// for debugging
//   	cout << lt << endl;
//   	cout << lg << endl;

  // ڤФϰϤλꡣüΣå女ɤɤ߼롣
  int SW2ndmesh;
  char str3[BUFFLEN];
  input.getline(str3, BUFFLEN);
  //istrstream istr3(str3);  // comment out Ocd. 4, 2007
  istringstream istr3((const char*)str3); // added Ocd. 4, 2007
  istr3 >> SW2ndmesh;

  // ڤФϰϤλꡣüΣå女ɤɤ߼롣
  int NE2ndmesh;
  char str4[BUFFLEN];
  input.getline(str4, BUFFLEN);
  //istrstream istr4(str4); // comment out Ocd. 4, 2007
  istringstream istr4((const char*)str4); // added Ocd. 4, 2007
  istr4 >> NE2ndmesh;

  // for debugging
  cout << SW2ndmesh << endl;
  cout << NE2ndmesh << endl;

  // ϥե̾

  char filename[TOTALOFILES][BUFFLEN];
  for (int i = 0; i < TOTALOFILES; i++) {
    char str[BUFFLEN];
    input.getline(str, BUFFLEN);
    //istrstream istr(str); // comment out Ocd. 4, 2007
    istringstream istr((const char*)str); // added Ocd. 4, 2007
    istr >> filename[i];
  }
  input.close();

  int totalcount = 1; // λϤֹ
  int rnum; // 켡åоݥǡԿ
  int cnum; // 켡åоݥǡ

  // ɸUTM ɸե˽
  // ե˵ҤƤ켡åν˲롣
  for (int id = 0; id < totalinput; id++) { // ϰ켡åθĿʬ
    minfo[id].pnum = totalcount;  // ΰ켡åκǽĺֹϿ

//       totalcount = OutputCoord(minfo[id].dname, totalcount,
// 							   filename[0]);
//      totalcount = OutputCoord(minfo[id].dname, totalcount,
//							   filename[0], lg, lt);
    // 켡å头Ȥɸǡ񤭽ФâϰΤߡ
    totalcount = OutputCoord(minfo[id].dname, totalcount, filename[0], 
                             lg, lt, SW2ndmesh, NE2ndmesh, &rnum, &cnum);

    minfo[id].rnum = rnum;  // ΰ켡åоݥǡԿϿ
    minfo[id].cnum = cnum;  // ΰ켡åоݥǡϿ

    cout << id << " " << minfo[id].m << " " << minfo[id].n << " " << minfo[id].dname 
      << " start point no.=" << minfo[id].pnum 
      << " line no.=" << minfo[id].rnum << " col no.=" << minfo[id].cnum << endl;
  }

  cout << "total count = " << totalcount - 1 << endl;

  ofstream output(filename[2]);
  if(!output) {
      cerr << "Cannot open " << filename[2] << endl;
    exit(1);
  }

  output << totalcount - 1 << endl; // ĺɽ

  // åɾ
  int rownum[maxm][maxn]; // 켡å˴ޤޤоΰιԿ
  int colnum[maxm][maxn]; // 켡å˴ޤޤоΰ
  int srownum[maxm][maxn]; // ¦Τ٤Ƥΰ켡åоݥǡԿ
  int wcolnum[maxm][maxn]; // ¦Τ٤Ƥΰ켡åоݥǡ

  for(int im = 0; im < maxm; im++) {
    for (int in = 0; in < maxn; in++) {
      rownum[im][in] = 0; colnum[im][in] = 0;
      srownum[im][in] = 0; wcolnum[im][in] = 0;
    }
  }

  for (int in= 0; in < totalinput; in++) {
    rownum[minfo[in].m-1][minfo[in].n-1] = minfo[in].rnum; // Կ
    colnum[minfo[in].m-1][minfo[in].n-1] = minfo[in].cnum; // 
  }

  for(int im = 0; im < maxm; im++) { // ϥեκ鱦
    int sumRow=0;
    for (int in = 1; in < maxn; in++) {  // ϥեβ
      sumRow += rownum[im][in-1];
      srownum[im][in] = sumRow;
      // cout << "im " << im << " in " << in << " sumRow = " << sumRow << endl;
    }
  }

  for(int in = 0; in < maxn; in++) { // ϥեβ
    int sumCol=0;
    for (int im = 1; im < maxm; im++) {  // ϥեκ鱦
      sumCol += colnum[im-1][in];
      wcolnum[im][in] = sumCol;
      // cout << "im " << im << " in " << in << " sumCol = " << sumCol << endl;
    }
  }

  for (int id= 0; id < totalinput; id++) {
    minfo[id].snum = srownum[minfo[id].m-1][minfo[id].n-1]; // ¦ιԿ
    minfo[id].wnum = wcolnum[minfo[id].m-1][minfo[id].n-1]; // ¦

    cout << id << " " << minfo[id].m << " " << minfo[id].n << " " << minfo[id].dname 
      << " start point no.=" << minfo[id].pnum 
      << " line no.=" << minfo[id].rnum << " col no.=" << minfo[id].cnum 
      << " south line no.=" << minfo[id].snum << " west no.=" << minfo[id].wnum << endl;
  }

  // ***** շν *****
  ofstream output3(filename[1]);
  if(!output3) {
    cerr << "Cannot open " << filename[1] << endl;
    exit(1);
  }
  output3 << "# շֹ շγʻҺɸ() "
	  << "շֹ()\n"
	  << "# () շֹϰϢȤϸ¤ޤ\n"
	  << "# () շֹĺƬ"
	  << "ȿ׼νǤ\n";

  int sap = -1;
  int wap = -1;
  int wsap = -1;
  int countVal = 1;

  for (int iq = 0; iq < totalinput; iq++) { // ϰ켡åǡεҽν
    int startpVal = minfo[iq].pnum; // ֹ
    int mVal = minfo[iq].m;     // Ͽޤΰ(x)
    int nVal = minfo[iq].n;     // Ͽޤΰ(y)
    int rVAL = minfo[iq].rnum;  //оݥǡιԿ
    int cVAL = minfo[iq].cnum;  //оݥǡ
    int sVAL = minfo[iq].snum;  // ¦Τ٤Ƥΰ켡åоݥǡԿ
    int wVAL = minfo[iq].wnum;  // ¦Τ٤Ƥΰ켡åоݥǡ

    // 켡åˤǤ륰åɾν
    int rpVal = startpVal;     // ǽĺֹ
    int nwn = sVAL + rVAL - 1; // ֹγֹ
    for (int i = 1; i < rVAL; i++) { // ԤΥ
      int vpVal = rpVal;  
      int nwm = wVAL + 1; // ֹγֹ
      for (int j = 1; j < cVAL; j++) { // Υ
        output3 << countVal                  // åֹ
        << " " << nwm                    // ֹ
        << " " << nwn                    // ֹ
        << " " << vpVal                  // ĺֹ
        << " " << vpVal + cVAL           // ĺֹ
        << " " << vpVal + cVAL + 1       // ĺֹ
        << " " << vpVal + 1 << "\n";     // ĺֹ
        countVal++;
        nwm++;
        vpVal++;
      }
      nwn--;
      rpVal += cVAL;
    }

    // ֡ʱˤΰ켡åδ֤ˤǤ륰åɤν
    int wflag = -1;
    if (mVal - 1 > 0) {// о1å꺸˥ǡ롣mval  1 Ϥޤ롣
      if (grid[mVal -2][nVal - 1] == 1) { // grid[][] źϡmVal-1, nVal-1 ߤ
                                     // о1å塣Ǥ if ʸϡоݤȤ
                                     // åɤоΰΰ켡åɤǤģĺ
                                     // ˥ǡ˿
                                     // ĤޤǺüüˤǤʤ켡å塣
        // ΰ켡åδ֤ˤǤ륰åɤν
        wflag = 1;
        for (int is = 0; is < totalinput; is++) {
          if (minfo[is].m == mVal - 1 && minfo[is].n == nVal) {
            wap = is; 
            // cout << "wap=" << wap<< endl;
            break; // ʬҤȤĺΥåɤõ wap ֤Ȥ롣
          }
        }
        int wpVal = minfo[wap].pnum + minfo[wap].cnum - 1;  // ǽΥåɤκĺֹ
        // cout << minfo[iq].dname << " wap = " << wap << " wpVal =" << wpVal << endl;
        int rowVal = sVAL + rVAL - 1; // ǽιֹ
        int pVal = startpVal;  // ǽΥåɤαĺֹ
        for (int ib = 1; ib < rVAL; ib++) {
        // ΰ켡åδ֤ˤǤ륰åɾν񤭽Ф
          output3 << countVal                  // åֹ
            << " " << wVAL                     // ֹʤֹѲʤ
            << " " << rowVal                   // ֹ
            << " " << wpVal                    // ĺֹ
            << " " << wpVal + minfo[wap].cnum  // ĺֹ
            << " " << pVal + cVAL              // ĺֹ
            << " " << pVal << "\n";            // ĺֹ
            countVal++;
            pVal += cVAL;
            wpVal += minfo[wap].cnum;
            rowVal--;
        }
      }
    }

    // ̴֡ʾ岼ˤΰ켡åδ֤ˤǤ륰åɤν
    int sflag = -1;
    if (nVal - 1 > 0) { // о1å겼˥ǡ롣nval  1 Ϥޤ롣
      if (grid[mVal -1][nVal - 2] == 1) { // grid[][] źϡmVal-1, nVal-1 ߤ
                                     // о1å塣Ǥ if ʸϡоݤȤ
                                     // åɤоΰΰ켡åɤǤģĲ
                                     // ˥ǡ˿
                                     // ĤޤǲüüˤǤʤ켡å塣
        // ΰ켡åδ֤ˤǤ륰åɤν
        sflag = 1;
        for (int is = 0; is < totalinput; is++) {
          if (minfo[is].m == mVal && minfo[is].n == nVal - 1)
          { sap = is; break; } // ʬҤȤĲΥåɤõ sap ֤Ȥ롣
        }
        int spVal = minfo[sap].pnum;   // ǽΥåɤκĺֹ
        int colVal = wVAL + 1;         // ǽֹ
        int pVal = startpVal + cVAL * (rVAL - 1);  // ǽΥåɤκĺֹ
        for (int ib = 1; ib < cVAL; ib++) {
          // ΰ켡åδ֤ˤǤ륰åɾν񤭽Ф
          output3 << countVal                   // åֹ
            << " " << colVal                  // ֹ
            << " " << sVAL         // ֹʤֹѲʤ
            << " " << pVal                    // ĺֹ
            << " " << spVal                   // ĺֹ
            << " " << spVal + 1               // ĺֹ
            << " " << pVal + 1 << "\n";       // ĺֹ
          countVal++;
          pVal++;
          spVal++;
          colVal++;
        }
      }
    }

    // ̡ʺ岼ˤΰ켡åδ֤ˤǤ륰åɤν
    if (wflag == 1 && sflag == 1) {
      if (grid[mVal -2][nVal - 2] == 1) { // grid[][] źϡmVal-1, nVal-1 ߤ
                                     // о1å塣Ǥ if ʸϡоݤȤ
                                     // åɤоΰΰ켡åɤǤģĲ
                                     // ĺ˥ǡ˿
                                     // ĤޤǺüüˤǤʤ켡å塣
        // 岼ΰ켡åδ֤ˤǤ륰åɤν
        for (int isw = 0; isw < totalinput; isw++) {
          if (minfo[isw].m == mVal - 1 && minfo[isw].n == nVal - 1)
          { wsap = isw; break; } // ʬҤȤĺΥåɤõ wsap ֤Ȥ롣
        }
        output3 << countVal                   // åֹ
          << " " << wVAL      // ֹ
          << " " << sVAL      // ֹ
          << " " 
          << minfo[wap].pnum + minfo[wap].cnum*minfo[wap].rnum - 1  // ĺֹ
          << " "
          << minfo[wsap].pnum + minfo[wsap].cnum - 1   // ĺֹ
          << " "
          << minfo[sap].pnum                           // ĺֹ
          << " "
          << startpVal + cVAL * (rVAL - 1)       // ĺֹ
          << "\n";
        countVal++;
      }
    }
  }

  cout << "total quadrilateral count = " << countVal - 1 << endl;
  output << countVal - 1 << endl;

  int totalGrid = (wcolnum[maxm-1][maxn-1]+colnum[maxm-1][maxn-1]-1)
                  *(srownum[maxm-1][maxn-1]+rownum[maxm-1][maxn-1]-1);
  
  cout << "total grid should be = " << totalGrid << endl;
  if (countVal-1 == totalGrid) {
    cout << "\nIt looks like the generated data is OK. Congraturations!" << endl;
  }
  else {
    cout << "The generated data is wrong!" << endl;
  }

  output.close();
  output3.close();

  return 0;
}

/*; end of file */
